#include <iostream>
using namespace std;
long long deg[11][19];
long long fact[19];
void initFact(void)
{fact[0]=1;
 for (int i=1;i<=18;i++) fact[i]=fact[i-1]*i;
}
void initDeg(void)
{int i,j;
 for (i=1;i<=10;i++) deg[i][0]=1;
 for (i=1;i<=10;i++)
  for (j=1;j<=18;j++) deg[i][j]=i*deg[i][j-1];
}
void initi(int n,int *a)
{int i;
 for (i=0;i<n;i++) a[i]=i;
}
bool isLucky(long long a)
{int s=0,c;
 long long m=1;
 while (a)
 {c=a%10;
  if (!c) return true;
  s+=c;
  m*=c;
  a/=10;
 }
 return (bool)!(m%s);
}
bool isLucky0(long long a)
{int s=0,m=1,c;
 while (a)
 {c=a%10;
  if (!c) return true;
  s+=c;
  m*=c;
  a/=10;
 }
 return false;
}
int digCnt(long long a)
{int c=0;
 while (a) {c++;a/=10;}
 return c;
}
bool nextComb(int n,int k,int *a)
{int i=k;
 while (i>0 && a[i]==n-k+i) i--;
 if (i){a[i]++;
        for (i++;i<=k;i++) a[i]=a[i-1]+1;
        return true;
       }
 return false;
}
bool nextPart(int n,int *p,int *r)
{int s,x,y=0;
 if (p[*r-1]>1){p[*r-1]--;
               p[(*r)++]=1;
               return true;
              }
 for (y=n;*r>0 && p[*r-1]==1;(*r)--,y--);
 if (!*r) return false;
 x=p[--*r]-1;
 p[*r]=x;
 y--;
 for ((*r)++;y>n;y-=x) p[(*r)++]=x;
 p[(*r)++]=n-y;
 return true;
}
long long Prod(int n,int *d,int *a)
{long long p=1;
 for (int i=1;i<=n;i++) p*=deg[d[i]][a[i]];
 return p;
}
long long Sum(int n,int *d,int *a)
{long long s=0;
 for (int i=1;i<=n;i++) s+=d[i]*a[i];
 return s;
}
long long permCnt(int N,int n,int *a)
{long long r=fact[N];
 for (int i=1;i<=n;i++) r/=fact[a[i]];
 return r;
}
int cmp(const void *a, const void *b)
{return *(int *)a-*(int *)b;
}
long long permNo(int n,const int *p)
{long long t, r=0;
 int c[10],s[32],i,j,k;
 memset(c,0,10*sizeof(int));
 for (i=0;i<n;i++) c[p[i]]++;
 for (i=0;i<n-1;i++)
 {memcpy(&s[i],&p[i],(n-i)*sizeof(int));
  qsort(&s[i],n-i,sizeof(int),cmp);
  k=0;
  while (i+k<n && s[i+k]<p[i])
  {t=fact[n-1-i];
   c[s[i+k]]--;
   for (j=0;j<10;j++) t/=fact[c[j]];
   r+=t;
   c[s[i+k]]++;
   do k++; while (i+k<n && s[i+k]==s[i+k-1]);
  }
  c[p[i]]--;
 }
 return r;
}
bool firstPerm(int p,const int *a,int *st,int *r,int n)
{int d,i;
 if (p==n) return true;
 for (d=a[p]; d<=9; d++) if (st[d]) break;
 if (d>9) return false;
 if (d==a[p]){r[p]=d;
              st[d]--;
              if (firstPerm(p+1,a,st,r,n)) return true;
              st[d]++;
              for (d=a[p]+1; d<=9; d++) if (st[d]) break;
              if (d>9) return false;
             }
 r[p++]=d;
 st[d]--;
 for (d=0;d<=9;d++)
  for (i=0;i<st[d];i++) r[p++]=d;
 return true;
}
long long zeroCnt(int digCnt)
{return deg[10][digCnt]-deg[10][digCnt-1]-deg[9][digCnt];
}
long long zeroCntBelow(int n,const int *a)
{long long r,d;int c,i=1,j;
 if (n<2) return 0;
 r=1;
 d=a[n-1];
 for (j=n-2;j>0;j--)
 {c=a[j];
  if (!c) r=d+1;
  else
  {r+=deg[10][i];
   r+=((c-1)*(deg[10][i]-deg[9][i]));
  }
  d=deg[10][i]*c+d;
  i++;
 }
 r+=((*a-1)*(deg[10][i]-deg[9][i]));
 return r;
}
long long permCnt(int digCnt)
{int d[10]={0},p[10]={0},n;
 long long c=0;
 p[1]=digCnt;
 n=1;
 do
 {if (n>9) continue;
  initi(n+1,d);
  do
   if (!(Prod(n,d,p)%Sum(n,d,p))) c+=permCnt(digCnt,n,p);
  while (nextComb(9,n,d));
 }while (nextPart(digCnt,&p[1],&n));
 return c;
}
long long permCntAbove(int N,const int *a)
{int d[10]={0},st[10],p[18]={0},r[32],n,i;
 long long c=0;
 p[1]=N;
 n=1;
 do
 {if (n>9) continue;
  initi(n+1,d);
  do
   if (!(Prod(n,d,p)%Sum(n,d,p)))
   {memset(st,0,10*sizeof(int));
    for (i=1;i<=n;i++) st[d[i]]=p[i];
    if (firstPerm(0,a,st,r,N)) c+=(permCnt(N,n,p)-permNo(N,r));
   }
  while (nextComb(9,n,d));
 }while (nextPart(N,&p[1],&n));
 return c;
}
long long luckyCnt(long long a,long long b)
{long long c=0,a1=a,b1=b;
 int digCnta=digCnt(a),digCntb=digCnt(b),i;
 int d[32];
 for (i=digCnta+1;i<digCntb;i++)
 {c+=zeroCnt(i);
  c+=permCnt(i);
 }
 for (i=digCnta-1;i>=0;i--) {d[i]=a1%10;a1/=10;}
 c+=(zeroCnt(digCnta)-zeroCntBelow(digCnta,d));
 if(isLucky0(a)) c++;
 c+=permCntAbove(digCnta,d);
 for (i=digCntb-1;i>=0;i--) {d[i]=b1%10;b1/=10;}
 if (digCnta==digCntb){c-=(zeroCnt(digCntb)-zeroCntBelow(digCntb,d));
                       c-=permCntAbove(digCntb,d);
                      }
 else {c+=zeroCntBelow(digCntb,d);
       c+=(permCnt(digCntb)-permCntAbove(digCntb,d));
      }
 if(isLucky(b)) c++;
 if(isLucky0(b)) c--;
 return c;
}
int main(void)
{long long a,b;
 initFact();
 initDeg();
 cin>>a>>b;
 cout<<luckyCnt(a,b)<<endl;
 return 0;
}
